# Solution to exercise 1
from casadi import *

# Use limited memory BFGS:
bfgs = False

# Declare variables
x = SX.sym('x',3)

f = x[0]**2 + 100 * x[2]**2
g = x[2] + (1-x[0])**2 - x[1]

# Create NLP function
nlp = SXFunction( nlpIn(x=w), nlpOut(f=f, g=g) )

# Formulate and solve NLP
solver = NlpSolver("ipopt", nlp)
if bfgs:
  solver.setOption("hessian_approximation", "limited-memory")
solver.init()
solver.setInput([2.5, 3.0, 0.75],'x0')
solver.setInput(0,'lbg')
solver.setInput(0,'ubg')
solver.evaluate()
print solver.getOutput('x')



# Task 1.4

from numpy import *
from matplotlib import pylab as plt
# Domain
x0 = linspace(-1,1,100)
x1 = linspace(-1,1,100)
[X0,X1] = plt.meshgrid(x0,x1)
# Function
F = exp(-X0**2-X1**2)*sin(4*(X0+X1+X0*X1**2))
# Plot the function
plt.clf()
plt.contour(X0,X1,F)
plt.colorbar()
plt.jet()
plt.xlabel("x0")
plt.ylabel("x1")
plt.show()


x = SX.sym("x",2)
f = exp(-x[0]**2 - x[1]**2 ) * sin(4*(x[0] + x[1] + x[0]*x[1]**2 ))
nlp = SXFunction(nlpIn(x=x),nlpOut(f=f))

solver = NlpSolver("ipopt",nlp) 
#solver.setOption("option_name", option_value)
solver.setOption("hessian_approximation","limited-memory")
solver.setOption("linear_solver", "ma27")
solver.init()
    

for x0 in ([0, 0], [0.9, 0.9], [-0.9, -0.9]):
    solver.setInput(x0, "x0")
    solver.setInput(-1,  "lbx")
    solver.setInput( 1,  "ubx")
    solver.evaluate()
    f_opt = solver.getOutput("f")
    x_opt = solver.getOutput("x")
